﻿Partial Class Form1

    ' ==============================================================================================================
    '   COMMANDS
    ' ==============================================================================================================
    Private Sub btn_GcodeStart_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeStart.ClickButtonArea
        StartRunningState()
    End Sub
    Private Sub btn_GcodePause_ClickButtonArea(ByVal Sender As Object, ByVal e As System.EventArgs) Handles btn_GcodePause.ClickButtonArea
        Pic_Toolpath.Focus()
        If Not btn_GcodeStart.Checked Then
            btn_GcodePause.Checked = False
            Return
        End If
        If btn_GcodePause.Checked Then
            UserInterfaceRedraw_Disable()
            RTB.ContextMenuStrip = CTX_Edit
            CNC_GcodeRunning = False
            CNC_TimedUpdateEnabled = False
            Slots.WriteSlot(SlotSpindleOnOff, 0)
            GcodeTime.Stop()
        Else
            UserInterfaceRedraw_Enable()
            CNC_KeySpacePressed = False
            GraphicThread_DrawToolpathImage(False)
            CNC_RestoreOutputSignals()
            RTB.ContextMenuStrip = Nothing
            CNC_GcodeRunning = True
            CNC_TimedUpdateEnabled = True
            GcodeTime.Start()
        End If
        SKIN_UpdateButtons()
    End Sub
    Private Sub btn_GcodeStop_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GCodeStop.ClickButtonArea
        btn_GCodeStop.Text = "STOP"
        CNC_GcodeRunning = True
        StopRunningState("")
        StopCalibrations()
        SKIN_UpdateButtons()
    End Sub
    Private Sub btn_GcodeLoad_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeLoad.ClickButtonArea
        SKIN_UpdateButtons()
        btn_GCodeStop.Text = "STOP"
        LoadGcodeDialog()
        btn_GcodeLoad.Checked = False
        Pic_Toolpath.Focus()
        SKIN_UpdateButtons()
        UserInterfaceRedraw_Disable()
        RTB.SelectionLength = 1
    End Sub
    Private Sub btn_GcodeRewind_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_GcodeRewind.ClickButtonArea
        RewindGcode()
    End Sub

    Friend Sub RewindGcode()
        If Not btn_GcodeRewind.Enabled Then Return
        SKIN_UpdateButtons()
        btn_GCodeStop.Text = "STOP"
        btn_GcodeRewind.Refresh()
        CNC_LineInExecution = 0
        CNC_LineToBeExecuted = 0
        UpdateUserInterfaceInfo()
        UserInterfaceRedraw_Disable()
        RTB.SelectionLength = 1
        CNC_Dest = CNC_Tip
        CNC_SetFeedMode(Feed_Modes.None)
        btn_GcodeRewind.Checked = False
        Pic_Toolpath.Focus()
        GraphicThread_DrawToolpathImage(False)
        ResetGcodeTime()
        SKIN_UpdateButtons()
    End Sub

    Friend Sub StartRunningState()
        If CNC_GcodeRunning Then
            btn_GcodeStart.Checked = True
            btn_GcodePause.Checked = True
            btn_GcodePause_ClickButtonArea(New Object, New System.EventArgs)
            Return
        End If
        If GCodeParsedLines.Length = 0 Then
            btn_GcodeStart.Checked = False
            SKIN_UpdateButtons()
            Return
        End If
        If GC_UsedZ AndAlso CNC_TestLowZ AndAlso _
           CNC_Tip.z < CNC_WarningZeta AndAlso Not btn_GcodePause.Checked Then
            If Form_MsgBox.Message_YesNo("WARNING: Z is low" + _
                                         vbCr + "Do you really want to start?") <> "YES" Then
                btn_GcodeStart.Checked = False
                SKIN_UpdateButtons()
                Return
            End If
        End If
        Pic_Toolpath.Focus()
        btn_GCodeStop.Text = "STOP"
        btn_GCodeStop.Checked = False
        btn_GcodePause.Checked = False
        btn_GcodeStart.Checked = True
        RTB.ReadOnly = True
        RTB.ContextMenuStrip = Nothing
        EnableAllControls(False)
        CalibrationButtons_Disable()
        GraphicThread_DrawToolpathImage(False)
        GraphicThread_WaitToolpathImageCompletion()
        CNC_RestoreOutputSignals()
        CNC_EnsureZeroToDeltaSlots()
        CNC_EnsureSafeValuesToInputSlots()
        ' ----------------------------------------------- ensure zero to unsed axis
        If Not GC_UsedZ Then CNC_Dest.z = 0
        If Not GC_UsedA Then CNC_Dest.a = 0
        If Not GC_UsedB Then CNC_Dest.b = 0
        ' -----------------------------------------------
        CNC_SetFeedMode(GCodeParsedLines(CNC_LineInExecution).FeedMode)
        CNC_LookAhead_LastSegment.InitWithValue(0)
        CNC_GcodeRunning = True
        CNC_TimedUpdateEnabled = True
        UserInterfaceRedraw_Enable()
        CNC_KeySpacePressed = False
        GcodeTime.Start()
        SKIN_UpdateButtons()
    End Sub

    Friend Sub StopRunningState(ByVal reason As String)
        If reason <> "" Then
            btn_GCodeStop.Text = "STOP (" + reason + ")"
            If reason = "end of program" Then
                RTB.ScrollToCaret()
            End If
        End If
        btn_GcodePause.Checked = False
        btn_GcodePause.Refresh()
        btn_GCodeStop.Checked = True
        btn_GCodeStop.Refresh()
        CNC_SetFeedMode(Feed_Modes.None)
        If Not CNC_FeedSpeedLockedType = CNC_FeedSpeedLockedTypes.AllLocked And _
           Not CNC_FeedSpeedLockedType = CNC_FeedSpeedLockedTypes.SpeedLocked Then
            CNC_SetSpeed(0)
        End If
        CNC_ResetCoolings()
        Slots.WriteSlot(SlotSpindleOnOff, 0)
        CNC_GcodeRunning = False
        CNC_TimedUpdateEnabled = False
        CNC_CipExecution = False
        CNC_CipExecute = False
        CNC_Dest = CNC_Tip
        GcodeTime.Stop()
        UserInterfaceRedraw_Disable()
        RTB.ReadOnly = False
        RTB.ContextMenuStrip = CTX_Edit
        btn_GcodeStart.Checked = False
        EnableAllControls(True)
        CalibrationButtons_Enable()
        CalibrationButtons_Uncheck
        SKIN_UpdateButtons()
        UpdateUserInterfaceInfo()
        'GraphicThread_DrawToolpathImage(True) ' this overrides the "Max Err" effects (but it is better to see them)
        Pic_Toolpath.Focus()
    End Sub
    Friend Sub ResetGcodeTime()
        GcodeTime.Reset()
        ShowGcodeTime()
    End Sub
    Private Sub EnableAllControls(ByVal enable As Boolean)
        btn_InOutEnabled.Enabled = enable
        btn_HalEnabled.Enabled = enable
        Menu_File.Enabled = enable
        Menu_Tools.Enabled = enable
        Menu_Skins.Enabled = enable
        ToolStripButton_LoadGcode.Enabled = enable
        ToolStripButton_SaveGcode.Enabled = enable
        ToolStripButton_SaveGcodeAs.Enabled = enable
        btn_GcodeLoad.Enabled = enable
        btn_GcodeRewind.Enabled = enable
        btn_Up.Enabled = enable
        btn_Down.Enabled = enable
        btn_GotoZero.Enabled = enable
        btn_GotoHome.Enabled = enable
        btn_GotoBottomLeft.Enabled = enable
        btn_GotoTopRight.Enabled = enable
        lbl_FirstSlot.Visible = enable
        txt_FirstSlot.Visible = enable
        btn_ZeroX.Enabled = enable
        btn_ZeroY.Enabled = enable
        btn_ZeroZ.Enabled = enable
        btn_ZeroA.Enabled = enable
        btn_ZeroB.Enabled = enable
    End Sub


    ' ==================================================================================================
    '   CROSS THREAD FUNCTIONS
    ' ==================================================================================================
    Friend Delegate Sub StopRunningStateCrossThread_Delegate(ByVal reason As String)
    Friend Sub StopRunningStateCrossThread(ByVal reason As String)
        If InvokeRequired Then
            BeginInvoke(New StopRunningStateCrossThread_Delegate(AddressOf StopRunningStateCrossThread), reason)
            'Invoke(New StopRunningStateCrossThread_Delegate(AddressOf StopRunningStateCrossThread), reason)
        Else
            StopRunningState(reason)
        End If
    End Sub

    Friend Delegate Sub MessageCrossThread_Delegate(ByVal text As String)
    Friend Sub MessageCrossThread(ByVal text As String)
        If InvokeRequired Then
            BeginInvoke(New MessageCrossThread_Delegate(AddressOf MessageCrossThread), text)
            'Invoke(New MessageCrossThread_Delegate(AddressOf MessageCrossThread), text)
        Else
            Form_MsgBox.Message_OK(text, , 16)
        End If
    End Sub

    ' ==================================================================================================
    '   Directly executed FUNCTIONS
    ' ==================================================================================================
    Private Function TestEmergency() As Boolean
        If CNC_KeySpacePressed Or CNC_TestEmergencyInput() Then
            StopRunningStateCrossThread("emergency stop")
            CNC_ResetAllAxis()
            Return True
        End If
        If CNC_TestLimitInputs() Then
            StopRunningStateCrossThread("limit switches")
            Return True
        End If
        Return False
    End Function


End Class
